DELIMITER $$

DROP PROCEDURE IF EXISTS `MT_Model_Delete` $$
CREATE PROCEDURE `MT_Model_Delete`
(
IN nModelId int,
IN sModelRef varchar(64)
)
BEGIN
	main: BEGIN
	DECLARE modelPrefix varchar(128);
	DECLARE modelRefPrefix varchar(64);
	DECLARE sqlString text(2048);
	DECLARE objectName varchar(128);
	DECLARE varroutine_schema varchar(128);
	DECLARE varroutine_type varchar(128);
	DECLARE vartable_schema varchar(128);
	DECLARE done INT DEFAULT 0;
	DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;

	IF nModelId=0 THEN
		LEAVE main;
	END IF;
	
	SET modelPrefix = CONCAT('M', nModelId, '\_%');
	SET modelRefPrefix = CONCAT(sModelRef, '\_%');
	
	block_3: BEGIN
		DECLARE cView CURSOR  FOR
			SELECT  TABLE_NAME, table_schema
			FROM    information_schema.VIEWS
			WHERE   (TABLE_NAME LIKE modelPrefix OR TABLE_NAME LIKE modelRefPrefix) AND table_schema = schema();
		
		DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
		
		SET done=0;
		OPEN cView;
		REPEAT
			FETCH cView INTO objectName, vartable_schema;
			
			IF NOT done THEN
				SET @stmt_text = CONCAT('drop view IF EXISTS ', objectName);
				PREPARE stmp from @stmt_text;
				EXECUTE stmp;
				deallocate prepare stmp;
			END IF;
		UNTIL done END REPEAT;
		
		CLOSE cView;
	END block_3;
	
	block_4: BEGIN
		DECLARE cTable CURSOR  FOR
			SELECT  TABLE_NAME, table_schema
			FROM    information_schema.TABLES
			WHERE   TABLE_NAME LIKE modelPrefix AND table_schema = schema();
	
		DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
	
		SET done=0;
		OPEN cTable;

		REPEAT
			FETCH cTable INTO objectName, vartable_schema;
			IF NOT done THEN
				SET @stmt_text = CONCAT('drop TABLE IF EXISTS ', objectName);
				PREPARE stmp from @stmt_text;
				EXECUTE stmp;
				deallocate prepare stmp;
			END IF;
		UNTIL done END REPEAT;
		
		CLOSE cTable;
	END block_4;
	
	DELETE FROM ModelPeriodScenario WHERE ModelPeriodScenario.ModelId = nModelId;
	END main;
END $$

DELIMITER ;